package com.tappli.android.airplanemodechanger;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.provider.Settings;
import android.view.View;

public class MainActivity extends Activity implements View.OnClickListener {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
    }

	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.switch_button:
			boolean airplaneMode = isAirplaneMode();
			setAirplaneMode(!airplaneMode);
			break;
		}
	}
	
	/**
	 * 機内モードかどうか判定する
	 * @return
	 */
	private boolean isAirplaneMode() {
		int status = Settings.System.getInt(getContentResolver(), Settings.System.AIRPLANE_MODE_ON, 0);
		return status != 0;
	}
	
	/**
	 * 機内モードを変更する
	 * @param enable
	 */
	private void setAirplaneMode(boolean enable) {
		// putInt()には[android.permission.WRITE_SETTINGS]が必要
		int value = enable ? 1 : 0;
		Settings.System.putInt(getContentResolver(), Settings.System.AIRPLANE_MODE_ON, value);
		
		Intent intent = new Intent(Intent.ACTION_AIRPLANE_MODE_CHANGED);
		intent.putExtra("state", value);
		sendBroadcast(intent);
	}
}